# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`postfix`](#postfix): configure postfix, main class
* [`postfix::config::main`](#postfixconfigmain): configures the main.cf file  This class is included by postfix::server and postfix::satellite to write the main.cf file
* [`postfix::config::master`](#postfixconfigmaster): configure master.cf
* [`postfix::service`](#postfixservice): create the postfix Service

### Defined types

* [`postfix::config::service`](#postfixconfigservice): define a service in master.cf file of postfix  See master(5) for details
* [`postfix::map`](#postfixmap): this defines a map for postfix  you can either use $source or $content parameter or use your own concat::fragment resources to add content to

## Classes

### <a name="postfix"></a>`postfix`

configure postfix, main class

#### Examples

##### 

```puppet
include postfix
```

#### Parameters

The following parameters are available in the `postfix` class:

* [`packages`](#packages)
* [`package_ensure`](#package_ensure)
* [`use_profile`](#use_profile)
* [`parameters`](#parameters)
* [`parameters_profiles`](#parameters_profiles)
* [`services`](#services)
* [`services_profiles`](#services_profiles)
* [`maps`](#maps)
* [`maps_profiles`](#maps_profiles)
* [`map_dir`](#map_dir)
* [`ssl_dir`](#ssl_dir)
* [`owner`](#owner)
* [`group`](#group)
* [`mode`](#mode)
* [`postmap_command`](#postmap_command)
* [`create_resources`](#create_resources)
* [`master_cf_file`](#master_cf_file)
* [`main_cf_file`](#main_cf_file)

##### <a name="packages"></a>`packages`

Data type: `Array`

packages to install

Default value: `['postfix']`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

defaults to 'install'

Default value: `'present'`

##### <a name="use_profile"></a>`use_profile`

Data type: `String[1]`

profile for the configuration to use.

Default value: `'none'`

##### <a name="parameters"></a>`parameters`

Data type: `Hash`

Hash of parameters for server
Remark: in hiera this parameter is hash merged

Default value: `{}`

##### <a name="parameters_profiles"></a>`parameters_profiles`

Data type: `Hash`

a Hash of profiles for parameters (see above)
if $postfix::use_profile is set then and
$parameters_profiles["$postfix::use_profile"] exists,
the profile is merged with $postfix::parameters.
Like this several config profiles can be defined
(eg. mailserver, mail satellite, etc.)
Remark: in hiera this parameter is hash merged

Default value: `{}`

##### <a name="services"></a>`services`

Data type: `Hash`

Hash of services for server
Defaults to {}
Remark: in hiera this parameter is hash merged

Default value: `{}`

##### <a name="services_profiles"></a>`services_profiles`

Data type: `Hash`

a Hash of profiles for services (see above)
if $postfix::use_profile is set then and
$services_profiles["$postfix::use_profile"] exists,
the profile is merged with $postfix::services.
Like this several config profiles can be defined
(eg. mailserver, mail satellite, etc.)
Remark: in hiera this parameter is hash merged

Default value: `{}`

##### <a name="maps"></a>`maps`

Data type: `Hash`

Hash of maps to generate
Defaults to {}
Remark: in hiera this parameter is hash merged

Default value: `{}`

##### <a name="maps_profiles"></a>`maps_profiles`

Data type: `Hash`

a Hash of profiles for maps (see above)
if $postfix::use_profile is set then and
$maps_profiles["$postfix::use_profile"] exists,
the profile is merged with $postfix::maps.
Like this several config profiles can be defined
(eg. mailserver, mail satellite, etc.)
Remark: in hiera this parameter is hash merged

Default value: `{}`

##### <a name="map_dir"></a>`map_dir`

Data type: `String`

directory for maps to create

Default value: `'/etc/postfix/maps'`

##### <a name="ssl_dir"></a>`ssl_dir`

Data type: `String`

directory for ssl to create

Default value: `'/etc/postfix/ssl'`

##### <a name="owner"></a>`owner`

Data type: `String`

file and directory owner

Default value: `'root'`

##### <a name="group"></a>`group`

Data type: `String`

file and directory group

Default value: `'root'`

##### <a name="mode"></a>`mode`

Data type: `String`

file mode

Default value: `'0644'`

##### <a name="postmap_command"></a>`postmap_command`

Data type: `String`

the postmap command to use

Default value: `'/usr/sbin/postmap'`

##### <a name="create_resources"></a>`create_resources`

Data type: `Hash`

generic create_resources (for certificates etc)

Default value: `{}`

##### <a name="master_cf_file"></a>`master_cf_file`

Data type: `String`

filename and path to master.cf file

Default value: `'/etc/postfix/master.cf'`

##### <a name="main_cf_file"></a>`main_cf_file`

Data type: `String`

filename and path to main.cf file

Default value: `'/etc/postfix/main.cf'`

### <a name="postfixconfigmain"></a>`postfix::config::main`

configures the main.cf file

This class is included by
postfix::server and
postfix::satellite to write the main.cf file

#### Parameters

The following parameters are available in the `postfix::config::main` class:

* [`main_cf_file`](#main_cf_file)
* [`owner`](#owner)
* [`group`](#group)
* [`mode`](#mode)
* [`parameters`](#parameters)

##### <a name="main_cf_file"></a>`main_cf_file`

Data type: `String`

name and path of the main.cf file

##### <a name="owner"></a>`owner`

Data type: `String`

owner of the main.cf file

##### <a name="group"></a>`group`

Data type: `String`

group of the main.cf file

##### <a name="mode"></a>`mode`

Data type: `String`

mode of the main.cf file

##### <a name="parameters"></a>`parameters`

Data type: `Hash`

The parameters to set in the main.cf file
Defaults to {}

Default value: `{}`

### <a name="postfixconfigmaster"></a>`postfix::config::master`

configure master.cf

#### Parameters

The following parameters are available in the `postfix::config::master` class:

* [`master_cf_file`](#master_cf_file)
* [`owner`](#owner)
* [`group`](#group)
* [`mode`](#mode)
* [`services`](#services)

##### <a name="master_cf_file"></a>`master_cf_file`

Data type: `String`

name and path for master.cf file

##### <a name="owner"></a>`owner`

Data type: `String`

owner of master.cf

##### <a name="group"></a>`group`

Data type: `String`

group of master.cf

##### <a name="mode"></a>`mode`

Data type: `String`

file mode of master.cf

##### <a name="services"></a>`services`

Data type: `Hash`

services to configure (also see README)

Default value: `{}`

### <a name="postfixservice"></a>`postfix::service`

create the postfix Service

#### Parameters

The following parameters are available in the `postfix::service` class:

* [`service_name`](#service_name)
* [`service_ensure`](#service_ensure)
* [`service_enable`](#service_enable)
* [`disabled_services`](#disabled_services)
* [`exec_postfix_enable`](#exec_postfix_enable)
* [`sync_chroot`](#sync_chroot)
* [`ensure_syslog_flag`](#ensure_syslog_flag)

##### <a name="service_name"></a>`service_name`

Data type: `String`

The name of the service

Default value: `'postfix'`

##### <a name="service_ensure"></a>`service_ensure`

Data type: `String`

state of the service.

Default value: `'running'`

##### <a name="service_enable"></a>`service_enable`

Data type: `Boolean`

if service should be enabled

Default value: ``true``

##### <a name="disabled_services"></a>`disabled_services`

Data type: `Array`

Array of Services to stop

Default value: `[]`

##### <a name="exec_postfix_enable"></a>`exec_postfix_enable`

Data type: `Boolean`

if set to true, we run postfix-enable

Default value: ``false``

##### <a name="sync_chroot"></a>`sync_chroot`

Data type: `Optional[String[1]]`

if set to a path, the according chroot
is synced.

Default value: ``undef``

##### <a name="ensure_syslog_flag"></a>`ensure_syslog_flag`

Data type: `Boolean`

if set to true, and sync_chroot is choosen,
a flag is set to allow logging from chroot
this is very OpenBSD specific !

Default value: ``false``

## Defined types

### <a name="postfixconfigservice"></a>`postfix::config::service`

define a service in master.cf file of postfix

See master(5) for details

#### Parameters

The following parameters are available in the `postfix::config::service` defined type:

* [`type`](#type)
* [`command`](#command)
* [`args`](#args)
* [`service_names`](#service_names)
* [`priv`](#priv)
* [`unpriv`](#unpriv)
* [`chroot`](#chroot)
* [`wakeup`](#wakeup)
* [`maxproc`](#maxproc)
* [`active`](#active)
* [`comments`](#comments)
* [`order`](#order)
* [`master_cf_file`](#master_cf_file)

##### <a name="type"></a>`type`

Data type: `String`

Specify the service type. one of:
inet, unix, fifo, pass.
defaults to 'unix'

Default value: `'unix'`

##### <a name="command"></a>`command`

Data type: `String`

The command to be executed.
defaults to $title

Default value: `$title`

##### <a name="args"></a>`args`

Data type: `Array`

Array of commands arguments

Default value: `[]`

##### <a name="service_names"></a>`service_names`

Data type: `Array`

Array of service names to configure.
defaults to [$title]

Default value: `[$title]`

##### <a name="priv"></a>`priv`

Data type: `String`

Whether or not access is restricted to the mail system.
defaults '-' (use built-in default)

Default value: `'-'`

##### <a name="unpriv"></a>`unpriv`

Data type: `String`

Whether the service runs with root privileges or as
the owner of the Postfix system.
defaults '-' (use built-in default)

Default value: `'-'`

##### <a name="chroot"></a>`chroot`

Data type: `String`

Whether or not the service runs chrooted to the mail
queue directory.
defaults '-' (use built-in default)

Default value: `'-'`

##### <a name="wakeup"></a>`wakeup`

Data type: `String`

Wake up time
defaults 'n' (default for postfix >= 3.0)

Default value: `'-'`

##### <a name="maxproc"></a>`maxproc`

Data type: `String`

The maximum number of processes that may execute
this service simultaneously
defaults 'n' (default for postfix >= 3.0)

Default value: `'-'`

##### <a name="active"></a>`active`

Data type: `Boolean`

if false, the service will not be activated (commented out)
default: true,

Default value: ``true``

##### <a name="comments"></a>`comments`

Data type: `Array`

Array of comments to print in front of the service definition.
defaults to [] (no comment)

Default value: `[]`

##### <a name="order"></a>`order`

Data type: `String`

order of the fragment (defaults to '55')

Default value: `'55'`

##### <a name="master_cf_file"></a>`master_cf_file`

Data type: `String`

target

### <a name="postfixmap"></a>`postfix::map`

this defines a map for postfix

you can either use $source or $content
parameter or use your own concat::fragment
resources to add content to the map.

#### Parameters

The following parameters are available in the `postfix::map` defined type:

* [`map_dir`](#map_dir)
* [`postmap_command`](#postmap_command)
* [`map_name`](#map_name)
* [`type`](#type)
* [`source`](#source)
* [`contents`](#contents)
* [`owner`](#owner)
* [`group`](#group)
* [`mode`](#mode)

##### <a name="map_dir"></a>`map_dir`

Data type: `String`

the directory to create the map in

##### <a name="postmap_command"></a>`postmap_command`

Data type: `String`

postmap command

##### <a name="map_name"></a>`map_name`

Data type: `String`

The name of the map defaults to $title

Default value: `$title`

##### <a name="type"></a>`type`

Data type: `String`

the type of the map
defaults to hash

Default value: `'hash'`

##### <a name="source"></a>`source`

Data type: `Optional[String[1]]`

source of the map
defaults to ''

Default value: ``undef``

##### <a name="contents"></a>`contents`

Data type: `Array`

Array of lines to add to the map
defaults to []

Default value: `[]`

##### <a name="owner"></a>`owner`

Data type: `String`

owner of the map file

##### <a name="group"></a>`group`

Data type: `String`

group of the map file

##### <a name="mode"></a>`mode`

Data type: `String`

file mode of the map file

